function demo()
    %  Created by Jiann-Ming Wu on 10/23/18.
    %  Copyright © 2018 Jiann-Ming Wu. All rights reserved.
tic;
L=6;
data_gen;
% data rotation
A=eye(3);
X=X*A;
plot3(X(:,1),X(:,2),X(:,3),'.');

ex =3;
switch ex
    case 1
        K=L^3;
        withSourceData=1;
        twoLevel=0;
        needAdjust = 1;
        obj = EMtoKmeansClustering(X,K,withSourceData,needAdjust,twoLevel);
        save temp;
        figure
        Y_new = obj.localCenters;
        plot3(X(:,1),X(:,2),X(:,3),'g.'); hold on
        plot3(Y_new(:,1),Y_new(:,2),Y_new(:,3),'rx');
        [mm_dis dd]=obj.calMeanDis();
        toc
    case 2
        for j=1:3
            K=27
            withSourceData=1;
            twoLevel=0;
            needAdjust = 0;
            % 1. construct an object
            obj = EMtoKmeansClustering(X,K,withSourceData,needAdjust,twoLevel);
            save temp;
            figure
            % 2. access properties of an object
            Y_new = obj.localCenters;
            plot3(X(:,1),X(:,2),X(:,3),'g.'); hold on
            plot3(Y_new(:,1),Y_new(:,2),Y_new(:,3),'rx');
            % 3. invoke a method
            [mm_dis(j) dd]=obj.calMeanDis();
            toc
        end
        mm_dis
        
    case 3
        
        K=27
        withSourceData=1;
        twoLevel=0;
        needAdjust = 0;
        % 1. construct an object
        obj = EMtoKmeansClustering(X,K,withSourceData,needAdjust,twoLevel);
        save temp;
        
        figure
        % 2. access properties of an object
        Y_new = obj.localCenters;
        plot3(X(:,1),X(:,2),X(:,3),'g.'); hold on
        plot3(Y_new(:,1),Y_new(:,2),Y_new(:,3),'rx');
        % 3. invoke a method
        [mm_dis_j dd]=obj.calMeanDis();
        DD = cross_dis(X,Y_new);
        [v ind]=min(DD');
        for j=1:size(Y_new,1)
            ind_j=find(ind==j);
            XX{j}=X(ind_j,:);
        end
        KK=8;
        K2=size(Y_new,1);
        parfor j=1:K2
            XXJ{j}= XX{j};
            obj_level2{j} = EMtoKmeansClustering(XXJ{j},KK,withSourceData,needAdjust,twoLevel);
        end
        toc
        save temp2;
        
        
end

