function demo3()
    %  Created by Jiann-Ming Wu on 10/23/18.
    %  Copyright © 2018 Jiann-Ming Wu. All rights reserved.
tic;
L=9;
data_gen;
% data rotation
A=eye(3);
X=X*A;
plot3(X(:,1),X(:,2),X(:,3),'.');


for j=1:3
    K=27
    withSourceData=1;
    twoLevel=0;
    needAdjust = 0;
    % 1. construct an object
    obj = EMtoKmeansClustering(X,K,withSourceData,needAdjust,twoLevel);
    
    figure
    % 2. access properties of an object
    Yj_new{j} = obj.localCenters;
    plot3(X(:,1),X(:,2),X(:,3),'g.'); hold on
    plot3(Yj_new{j}(:,1),Yj_new{j}(:,2),Yj_new{j}(:,3),'rx');
    % 3. invoke a method
    [mm_dis_j(j) dd]=obj.calMeanDis();
end
mm_dis_j
[mean index] = min(mm_dis_j);
Y_new = Yj_new{index};


DD = cross_dis(X,Y_new);
[v ind]=min(DD');
for j=1:size(Y_new,1)
    ind_j=find(ind==j);
    XX{j}=X(ind_j,:);
end


KK=27;
K2=size(Y_new,1);
parfor j=1:K2
    XXJ{j}= XX{j};
    obj_level2{j} = EMtoKmeansClustering(XXJ{j},KK,withSourceData,needAdjust,twoLevel);
end

figure
plot3(X(:,1),X(:,2),X(:,3),'g.'); hold on
for k = 1:K2
    Yi_new = obj_level2{k}.localCenters;
    plot3(Yi_new(:,1),Yi_new(:,2),Yi_new(:,3),'rx'); hold on
end
save temp3
toc


end

